import urllib
import re
import sys

txt_ids_path = "pci.ids"
txt_dup_path = "duplicate_ids"

if sys.argv > 1:
    page_path = sys.argv[1]
else:
    print("Error: arg1 must be path to local html-file")
    exit(1)

if page_path == "help":
    print("Usage:\n\tparse_pci.py path_to_html [path_to_pci.ids]")
    exit(0)

if len(sys.argv) > 2:
    txt_ids_path = sys.argv[2]

found_txt_ids = []
page_ids = []
txt_ids = []
found_page_ids = []
not_found = []
dup_ids = []

page_pattern = '<td>[0-9]+</td><td>0x[\w]+</td><td>0x[\w]+</td><td>[\w\/ \.-]+</td>'
p = re.compile(page_pattern)

def numstrip(s):
    mo = re.search('[.]*#', s)
    if mo:
        return mo.start()

for line in open(txt_dup_path):
    s = '|'.join(["xx", line[2:6], line[9:13], line[14:-1]])
    dup_ids.append(s.split('|'))

for line in open(page_path):
    result = p.findall(line)
    if result:
        k = result[0].replace('0x', '').split("</td><td>")
        page_ids.append('|'.join(["     " + str(k[0])[4:], k[1], k[2], str(k[3])[:-5], ""]).split('|'))

vendor=""
s=""
for line in open(txt_ids_path):
    if line[0] == "C" and line[1] == " ":
        break
    t = numstrip(line)
    if len(line) > 5 and t != 0:
        if line[0] != "\t":
            vendor = line[0:4]
            s = line[:t].replace('\n', '') + "  vendor"
        else:
            s = vendor + "  " + line[:t].replace('\t', '')
        txt_ids.append(s.split('  '))


for k in page_ids:
    for ids in txt_ids:
        if k[1] == ids[0] and k[2] == ids[1] and ids[2] != "vendor":
            found_txt_ids.append(ids)
            k[4] = str(ids[2])[:-1]
            found_page_ids.append(k)

for i in dup_ids:
    for j in page_ids:
        if i[1] == j[1] and i[2] == j[2]:
            j[0] = "dup  " + str(j[0])[5:]
            if str(j[4]) == "":
                j[4] = str(i[3] + " (from: " + txt_dup_path + ")")

print("flag N - vendor     id - html name -- file name")
print("=================================================")
for i in page_ids:
    if i not in found_page_ids:
        if str(i[0])[:3] != "dup":
            i[0] = "---  " + str(i[0])[5:]
            not_found.append(i)
    if i[3] <> i[4]:
        print(i[0] + " - 0x" + i[1] + " 0x" + i[2] + " - " + i[3] + " -- " + i[4])
    else:
        print(i[0] + " - 0x" + i[1] + " 0x" + i[2] + " - " + i[3])


print("=================================================")
#print("    found:   " + str(len(found_page_ids)))
print("not found:   " + str(len(not_found)))
print("ids in html: " + str(len(page_ids)))
print("ids in " + txt_ids_path + ": " + str(len(txt_ids)))
