#define _GNU_SOURCE
#define __USE_GNU

#include <unistd.h>
#include <stdio.h>
#include <sys/mman.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <string.h>
#include <errno.h>
#include <stdlib.h>

#include <sched.h>
#include <math.h>
#include "mct_test.h"

extern int verbose;
extern char dev_file_path[1024];

#define CPU_NAME "cpu"

int run_cpu_test(int check)
{
	int number = 0;
	unsigned long old_mask;
	char *ptr = dev_file_path;
	if (sched_getaffinity(getpid(), sizeof(old_mask), (cpu_set_t *)(&old_mask)) == -1) {
		myprintf("sched_getaffinity(): %s [%d]\n", strerror(errno), errno);
		return TEST_FAIL;
	}

	if (strcasestr(dev_file_path, CPU_NAME)) {
		ptr = (char *)(dev_file_path + 3);
	}

	number = atoi(ptr);
	if (check < 0) check = number;
	myprintf("Check for cpu: %d [%s] == %d\n",
		 number, dev_file_path, check);
	int rr = CPU_ISSET(number, (cpu_set_t *)(&old_mask));
	if (rr > 0 && check == number)
		return TEST_PASS;
	else
		return TEST_FAIL;
}
