#include <stdio.h>
#include <errno.h>
#include <sys/ioctl.h>
#include "mc7603.h"
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <string.h>
#include <unistd.h>

#include "mct_test.h"

extern int verbose;
extern char dev_file_path[1024];

int run_mc7603_test(void)
{
	int fd, res = TEST_FAIL;
	long fdres = 0;

	myprintf("run MC76.03 test...\n");
	myprintf("open device: [%s]\n", dev_file_path);
	fd = open(dev_file_path, O_RDWR);
	if (fd >= 0) {
		res = ioctl(fd, IOCTL_MC7603_GET_BOOT_RC, &fdres);
		myprintf("Result for %s : %ld -- res: %d\n",
			 dev_file_path, fdres, res);
		if (res >= 0 && fdres == 0)
			res = TEST_PASS;
		close(fd);
		myprintf("close device: [%s]\n", dev_file_path);
	}

	return res;
}
